if(!com) var com={};
if(!com.clipta) com.clipta={};
if(!com.clipta.feed) com.clipta.feed={};

//Feed Model:
com.clipta.feed.CliptaFeedData=function(id,url){
	this.id=id
	this.url=url
	this.title=''
	this.items=[]
	this.ttl=15
	this.limitItemsCount=15
	this.clearItems=function(){
		this.items=[]
	}
}

//Feed Item Model:
com.clipta.feed.CliptaFeedItemData=function(title,link,description,date,imageUrl){
	this.title=title
	this.link=link
	this.description=description
	this.imageUrl=imageUrl
	this.date=date
}

// FeedView:
com.clipta.feed.CliptaFeedsView={
	buttonTimer:null,
	buttonCurrentTitleIndex:0,
	init:function(){
		window.addEventListener("load", this.update, false);
		//CliptaFeedsView.update()
	},

	update:function(){
		//LOG('Updating the feed view')
		
		var newsFeedItems=com.clipta.feed.CliptaFeeds.feeds['clipta_news'].items
		if(newsFeedItems.length>0){
			com.clipta.feed.CliptaFeedsView.removeAllMenuItem()
			for(var i in newsFeedItems){
				//LOG(newsFeedItems[i].title)
				com.clipta.feed.CliptaFeedsView.addMenuItem(newsFeedItems[i])
			}
			buttonCurrentTitleIndex=0
			com.clipta.feed.CliptaFeedsView.changeButton()
			if(!com.clipta.feed.CliptaFeedsView.buttonTimer){
				
				com.clipta.feed.CliptaFeedsView.startButtonTimer()
			}
		}else{
				com.clipta.feed.CliptaFeedsView.stopButtonTimer()
		}

	},

	startButtonTimer:function(){
		
		var event 
		   = { notify: function(timer) { com.clipta.feed.CliptaFeedsView.changeButton(); } }
		 com.clipta.feed.CliptaFeedsView.buttonTimer 
		   = Components.classes["@mozilla.org/timer;1"]
			   .createInstance(Components.interfaces.nsITimer);
		 com.clipta.feed.CliptaFeedsView.buttonTimer.initWithCallback(
		   event,
			30000,
			
		   Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
		LOG('buttonTimer started')
	},

	changeButton:function(){
		if(!document.getElementById('cliptaTB-NewsMenu'))
				return false;
		var menu=document.getElementById('cliptaTB-NewsMenu')
		var newsFeedItems=com.clipta.feed.CliptaFeeds.feeds['clipta_news'].items
		menu.setAttribute("label",newsFeedItems[com.clipta.feed.CliptaFeedsView.buttonCurrentTitleIndex].title)
		com.clipta.feed.CliptaFeedsView.buttonCurrentTitleIndex++
		if(com.clipta.feed.CliptaFeedsView.buttonCurrentTitleIndex>Math.min(newsFeedItems.length-1,14)){
			com.clipta.feed.CliptaFeedsView.buttonCurrentTitleIndex=0
		}
	},

	stopButtonTimer:function(){
		if(this.buttonTimer){
			this.buttonTimer.cancel()
			this.buttonTimer=null
		}
	},

	removeAllMenuItem:function(){	
		if(!document.getElementById('cliptaTB-NewsMenuItems'))
				return false;			
		var menuItems=document.getElementById('cliptaTB-NewsMenuItems')
		while (menuItems.hasChildNodes()) {
            menuItems.removeChild(menuItems.firstChild);
        }
	},
	addMenuItem:function(feedItemData){		
		if(!document.getElementById('cliptaTB-NewsMenuItems'))
				return false;
		var menuItems=document.getElementById('cliptaTB-NewsMenuItems')
		var newItem = document.createElement("richlistitem");
		newItem.setAttribute("type",'feeditem');
		newItem.setAttribute("title",feedItemData.title);
		newItem.setAttribute("link",feedItemData.link);
		newItem.setAttribute("description",feedItemData.description);		
		newItem.setAttribute("date",feedItemData.date.toLocaleFormat("%I:%M %p"));
		newItem.setAttribute("imageUrl",feedItemData.imageUrl);
		menuItems.appendChild(newItem);
	}
}

com.clipta.feed.CliptaFeeds={
	feeds:{"clipta_news":new com.clipta.feed.CliptaFeedData("clipta_news","http://news.clipta.com/rss.xml")},
	checkInterval:com.clipta.toolbar.prefs.getIntPref("feedCheckInterval"),
	updateTimer:null,
	updateQueue:[],

	init:function(){
		//LOG('init')
		this.startUpdateTimer()
		this.checkFeeds()
		
	},
	
	startUpdateTimer:function(){
		 var event 
		   = { notify: function(timer) { com.clipta.feed.CliptaFeeds.checkFeeds(); } }
		 this.updateTimer 
		   = Components.classes["@mozilla.org/timer;1"]
			   .createInstance(Components.interfaces.nsITimer);
		 this.updateTimer.initWithCallback(
		   event,
			this.checkInterval*1000*60,
			
		   Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
		//LOG('updateTimer started')
	},
	stopUpdateTimer:function(){
		if(this.updateTimer){
			this.updateTimer.cancel()
				this.updateTimer=null
		}
		//LOG('updateTimer stoped')
	},
	// checking feeds and reloading if necessary:
	checkFeeds:function(forceUpdate){
		//LOG('checking feeds');
		for(var i in this.feeds){
			var currentFeed=this.feeds[i]
			var feedFileContent=com.clipta.file.CliptaFileUtils.read(currentFeed.id)
			if(!feedFileContent || forceUpdate){
				this.updateQueue.push(currentFeed)
			}else{
				var lastModified=com.clipta.file.CliptaFileUtils.getLastModifyDate(currentFeed.id)
				var now = new Date()
				var timeDiff=now-lastModified
					//LOG(currentFeed.id+" timeDiff: "+timeDiff/1000/60)
				if(timeDiff>=currentFeed.ttl*60*1000){
					this.updateQueue.push(currentFeed)
				}else{
					if(currentFeed.items.length==0)
						this.onFeedLoad(currentFeed,feedFileContent,true)
				}
			}
		}
		if(this.updateQueue.length>0) this.updateFeeds()
	},
	
	updateFeeds:function(){
		LOG('updating feeds from source')
		for (var i in this.updateQueue){
			var currentFeed=this.updateQueue.shift()
			var httpReq=new com.clipta.net.HttpRequest()
			httpReq.reqUrl=currentFeed.url
			httpReq.feedObj=currentFeed
			httpReq.onLoad=function(success,response,req){
				if(success && response && response.length>0){
					//LOG('feed loaded from source')
					com.clipta.feed.CliptaFeeds.onFeedLoad(req.feedObj, response)
				}else{
					//LOG('Error loading feed: '+req.feedObj.id)
				}
			}
			httpReq.send(null)
		}
		
	},

	onFeedLoad:function(feedObject,content,skipSave){
		LOG('feed loaded')
		var contentForE4X = content.replace(/^<\?xml\s+version\s*=\s*(["'])[^\1]+\1[^?]*\?>/, ""); // bug 336551
		var rss = new XML(contentForE4X );
		
		var items = rss.channel.item
		if(items && items.length() >0 && !skipSave){
			com.clipta.file.CliptaFileUtils.save(feedObject.id,content)	
		}
		feedObject.clearItems()
		var ttl = rss.channel.ttl
		if(ttl && ttl>0){
			feedObject.ttl=ttl		
		}
		var media = new Namespace('http://search.yahoo.com/mrss/');
		for(var i=0;i<items.length() && i<feedObject.limitItemsCount;i++){
			var description=String(items[i].description).replace(/<[^>]+>/g, "")
			var pubDate=new Date(Date.parse(items[i].pubDate))
			var imageUrl=''
			
			if(items[i].media::content && items[i].media::content.@medium=="image"){
				imageUrl=items[i].media::content.@url
			}
			//LOG(items[i].media::content.@medium)
			//LOG(imageUrl)
			feedObject.items.push(new com.clipta.feed.CliptaFeedItemData(items[i].title,items[i].link,description,pubDate,imageUrl))			
		}
		//LOG(CliptaFeeds.feeds)
		this.updateCheckInterval()
		this.updateView()
	},

	updateView:function(){
		com.clipta.feed.CliptaFeedsView.update()
	},
	updateCheckInterval:function(minutes){
		var minTTL=999999999
		for (var i in this.feeds){
			if(this.feeds[i].ttl>0 && this.feeds[i].ttl<minTTL){
				minTTL=this.feeds[i].ttl
			}
		}
		minTTL++; // check 1 minute after the feed ttl
		com.clipta.toolbar.prefs.setIntPref('feedCheckInterval',minTTL)
		this.checkInterval=minTTL
		this.stopUpdateTimer()
		this.startUpdateTimer()
	}
}


com.clipta.feed.CliptaFeeds.init()
com.clipta.feed.CliptaFeedsView.init()
